/**********************************************************************
 
	Copyright (C) 2007 Tomohito Nakajima <nakajima@zeta.co.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/

#ifndef __V_SERIALIZED_EXEC_M_H___
#define __V_SERIALIZED_EXEC_M_H___

template<typename RET>
RET v_serialized_exec_func(RET(WINAPI *func)()){
	RET ret;
	v_serialized_exec_func_s0<RET,RET(WINAPI *)()> s(ret, func);
	s.dummy();
	return ret;
}

template<typename RET, typename A1, typename B1>
RET v_serialized_exec_func(RET(WINAPI *func)(B1), A1 a1){
	RET ret;
	v_serialized_exec_func_s1<RET,RET(WINAPI *)(B1),A1> s(ret, func,a1);
	s.dummy();
	return ret;
}

template<typename RET, typename A1, typename A2, typename B1, typename B2>
RET v_serialized_exec_func(RET(WINAPI *func)(B1,B2), A1 a1, A2 a2){
	RET ret;
	v_serialized_exec_func_s2<RET,RET(WINAPI *)(B1,B2),A1,A2> s(ret, func,a1,a2);
	s.dummy();
	return ret;
}

template<typename RET, typename A1, typename A2, typename A3, typename B1, typename B2, typename B3>
RET v_serialized_exec_func(RET(WINAPI *func)(B1,B2,B3), A1 a1, A2 a2, A3 a3){
	RET ret;
	v_serialized_exec_func_s3<RET,RET(WINAPI *)(B1,B2,B3),A1,A2,A3> s(ret, func,a1,a2,a3);
	s.dummy();
	return ret;
}

template<typename RET, typename A1, typename A2, typename A3, typename A4, typename B1, typename B2, typename B3, typename B4>
RET v_serialized_exec_func(RET(WINAPI *func)(B1,B2,B3,B4), A1 a1, A2 a2, A3 a3, A4 a4){
	RET ret;
	v_serialized_exec_func_s4<RET,RET(WINAPI *)(B1,B2,B3,B4),A1,A2,A3,A4> s(ret, func,a1,a2,a3,a4);	
	s.dummy();
	return ret;
}

template<typename RET, typename A1, typename A2, typename A3, typename A4, typename A5, typename B1, typename B2, typename B3, typename B4, typename B5>
RET v_serialized_exec_func(RET(WINAPI *func)(B1,B2,B3,B4,B5), A1 a1, A2 a2, A3 a3, A4 a4, A5 a5){
	RET ret;
	v_serialized_exec_func_s5<RET,RET(WINAPI *)(B1,B2,B3,B4,B5),A1,A2,A3,A4,A5> s(ret, func,a1,a2,a3,a4,a5);	
	s.dummy();
	return ret;
}

template<typename RET, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename B1, typename B2, typename B3, typename B4, typename B5, typename B6>
RET v_serialized_exec_func(RET(WINAPI *func)(B1,B2,B3,B4,B5,B6), A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6){
	RET ret;
	v_serialized_exec_func_s6<RET,RET(WINAPI *)(B1,B2,B3,B4,B5,B6),A1,A2,A3,A4,A5,A6> s(ret, func,a1,a2,a3,a4,a5,a6);
	s.dummy();
	return ret;
}

template<typename RET, typename A1, typename A2, typename A3, typename A4, typename A5, typename A6, typename A7, typename B1, typename B2, typename B3, typename B4, typename B5, typename B6, typename B7>
RET v_serialized_exec_func(RET(WINAPI *func)(B1,B2,B3,B4,B5,B6,B7), A1 a1, A2 a2, A3 a3, A4 a4, A5 a5, A6 a6, A7 a7){
	RET ret;
	v_serialized_exec_func_s7<RET,RET(WINAPI *)(B1,B2,B3,B4,B5,B6,B7),A1,A2,A3,A4,A5,A6,A7> s(ret, func,a1,a2,a3,a4,a5,a6,a7);
	s.dummy();
	return ret;
}

#endif