/**********************************************************************
 
	Copyright (C) 2003 Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/


#include	"memory_debug.h"
#include	"xlerror.h"
#include	"xl.h"

#include "svg2gb.h"

extern L_CHAR *unitname;
extern char * data_encoding;
extern CODE_METHOD *data_encoding_cm;
XL_SEXP * xl_OutputPP();

void
init_OutputPP(XLISP_ENV * env)
{
	set_env(env,l_string(std_cm,"OutputPP"),
		get_func_prim(xl_OutputPP,FO_APPLICATIVE,0,1,1));
}

XL_SEXP *
xl_OutputPP(XLISP_ENV * env,XL_SEXP * s,XLISP_ENV * a,XL_SYM_FIELD * sf)
{
XL_SEXP *ss;
SVG2GB_CONTEXT *ctx;
L_CHAR *const_pp = l_string(std_cm, "pp");
L_CHAR *const_info = l_string(std_cm, "info");
L_CHAR *const_vct = l_string(std_cm, "vct");
L_CHAR *const_card = l_string(std_cm, "card");
L_CHAR *const_onmap = l_string(std_cm, "onmap");
L_CHAR *const_scheme = l_string(std_cm, "scheme");
//L_CHAR *const_visible_resolution = l_string(std_cm, "visible_resolution");

SVG2GB_OUTPUTPP_INFO o;
SVG2GB_OUTPUTVCT_INFO vct_info;

int p;

extern int lod_max;
extern int lod_min;
extern double max_resolution;
extern int point_nos;
L_CHAR * dotper;
XL_SEXP * ret;
CODE_METHOD *cm=0;

	memset(&vct_info, 0, sizeof(vct_info));
	memset(&o, 0, sizeof(o));

	ctx = svg2gb_get_context();
	ss = car(s);
	
	cm = std_cm;
	for( ; sf; sf=sf->next){
		if( l_strcmp(sf->name, const_pp) == 0	){
			strcpy(o.filename_pp, n_string(cm, sf->data));
		}
		else if( l_strcmp(sf->name, const_info) == 0){
			strcpy(o.filename_inf, n_string(cm, sf->data));
		}
		else if( l_strcmp(sf->name, const_vct) == 0){
			strcpy(vct_info.filename, n_string(cm, sf->data));
		}
		else if( l_strcmp(sf->name, const_card) == 0){
			strcpy(vct_info.card_file, n_string(cm, sf->data));
		}
		else if( l_strcmp(sf->name, const_onmap) == 0){
			strcpy(vct_info.onmap_file, n_string(cm, sf->data));
		}
		else if( l_strcmp(sf->name, const_scheme) == 0){
			strcpy(vct_info.scheme, n_string(cm, sf->data));
		}
		else if ( l_strcmp(sf->name,l_string(cm, "unitname")) == 0 ) {
			if ( unitname )
				d_f_ree(unitname);
			unitname = ll_copy_str(sf->data);
		}
		else if ( l_strcmp(sf->name,l_string(std_cm,"encoding")) == 0 ){
			if ( data_encoding )
				d_f_ree(data_encoding);
			data_encoding = ln_copy_str(std_cm,sf->data);
			data_encoding_cm = search_cm(data_encoding);
			if ( data_encoding_cm == 0 )
				goto encoding_error;
			cm = data_encoding_cm;
		}
		else if( l_strcmp(sf->name,l_string(std_cm, "visible_resolution")) == 0)
		{
			strncpy(vct_info.visible_resolution, n_string(std_cm, sf->data), sizeof(vct_info.visible_resolution)-1);
		}
	}
	if ( o.filename_inf[0] == 0 ) {
		for ( p = strlen(o.filename_pp)-1 ;
			p >= 0 &&
			o.filename_pp[p] != '/' ; 
			p -- );
		p ++;
		strcpy(o.filename_inf,&o.filename_pp[p]); 
		for ( p = strlen(o.filename_inf)-1 ;
			p >= 0 &&
			o.filename_inf[p] != '.' ; 
			p -- );
		if ( p < 0 )
			p = strlen(o.filename_inf);
		strcpy(&o.filename_inf[p],".inf");
	}

	if ( vct_info.filename[0] == 0){
		for ( p = strlen(o.filename_pp)-1 ;
			p >= 0 &&
			o.filename_pp[p] != '/' ; 
			p -- );
		p ++;
		strcpy(vct_info.filename, &o.filename_pp[p]); 
		for ( p = strlen(vct_info.filename)-1 ;
			p >= 0 &&
			vct_info.filename[p] != '.' ; 
			p -- );
		if ( p < 0 )
			p = strlen(vct_info.filename);
		strcpy(&vct_info.filename[p], ".vct");
	}

	gc_push(0,0,"svg2gb");
	
	if(point_nos){
		setup_minrect();
		
		ss_printf("\nNUMMBERING...\n");
		numbering();
		ss_printf("INFORMATION...\n");
		
		output_info(&o);
		
		ss_printf("LOD CONTROL...\n");
		lod_control();
		
		ss_printf("MAKING TREE...\n");
		make_tree();
		ss_printf("SAVE PDB FILE...\n");
		
		save_pdb(&o);
	}

	if(pdb_mark_tags){
		ss_printf("OUTPUT VCT FILE...\n");
		output_vct(&vct_info);
	}

	ss_printf("END\n");
	ss_printf("\tminrect = (%f %f)-(%f %f)\n",
		minrect.tl.x,
		minrect.tl.y,
		minrect.br.x,
		minrect.br.y);
	ss_printf("lod %i-%i\n",lod_min,lod_max);
	ss_printf("resolution = %lf\n",1/max_resolution);
	
	gc_pop(0,0);

	if ( unitname ) {
		dotper = d_alloc(
			sizeof(L_CHAR)*
			(l_strlen(unitname) + 10)
			);
		memcpy(dotper,l_string(std_cm,"dot/"),sizeof(L_CHAR)*4);
		memcpy(&dotper[4],unitname,
			(l_strlen(unitname)+1)*
			sizeof(L_CHAR));
	}
	else	dotper = 0;
	
	ret = List(
		List(n_get_symbol("point-nos"),
			get_integer(point_nos,0),
			-1),
		List(n_get_symbol("minrect"),
			get_floating(minrect.tl.x,unitname),
			get_floating(minrect.tl.y,unitname),
			get_floating(minrect.br.x,unitname),
			get_floating(minrect.br.y,unitname),
			-1),
		List(n_get_symbol("resolution"),
			get_floating(1/max_resolution,dotper),
			-1),
		List(n_get_symbol("lod"),
			get_integer(lod_min,0),
			get_integer(lod_max,0),
			-1),
		-1);
	if ( dotper )
		d_f_ree(dotper);
	return ret;
/*
type_missmatch:
	return get_error(
		s->h.file,
		s->h.line,
		XLE_SEMANTICS_TYPE_MISSMATCH,
		l_string(std_cm,"OutputPP"),
		n_get_string("type missmatch"));
*/
encoding_error:
	return get_error(
		s->h.file,
		s->h.line,
		XLE_PROTO_INV_PARAM,
		l_string(std_cm,"OutputPP"),
		n_get_string("encoding error"));
}
