/**********************************************************************
 
	Copyright (C) 2003 Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/


#include	"memory_debug.h"
#include	"xl.h"
#include	"xlerror.h"

XL_SEXP * xl_SetEA();
XL_SEXP * sort_list();
XL_SEXP * get_join_option();
XL_SEXP * njoin_cmp_s();
XL_SEXP * xl_GetElement();
void gc_gb_sexp();

//int
//njoin_cmp_field_list(XL_SEXP ** retp,XL_SEXP * flist,
//	XL_SEXP * s1,XL_SEXP * s2);

void
init_SetEA(XLISP_ENV * env)
{
	set_env(env,l_string(std_cm,"SetEA"),
		get_func_prim(xl_SetEA,FO_APPLICATIVE,0,4,4));
}

XL_SEXP *
xl_SetEA(XLISP_ENV * env,XL_SEXP * s)
{
XL_SEXP * e;
XLISP_ENV * _e;
XL_SEXP * index;
L_CHAR * _index;
char * buf;
STREAM * st;
	e = get_el(s,1);
	switch ( get_type(e) ) {
	case XLT_ENV:
		_e = e->env.data;
		break;
	case XLT_NULL:
		_e = env;
		break;
	default:
		goto type_missmatch;
	}
	index = get_el(s,2);
	buf = 0;
	switch ( get_type(index) ) {
	case XLT_SYMBOL:
		_index = index->symbol.data;
		break;
	case XLT_STRING:
		_index = index->string.data;
		break;
	case XLT_INTEGER:
		if ( index->integer.unit ) {
			st = s_open_string_write(&int_cm);
			s_printf(st, I64_FORMAT "%ls",
				index->integer.data,
				index->integer.unit);
			_index = ll_copy_str(s_get_l_string(st));
			s_close(st);
			set_buffer(_index);
		}
		else {
			buf = d_alloc(50);
			sprintf(buf, I64_FORMAT,
				index->integer.data);
			_index = l_string(std_cm,buf);
		}
		break;
	case XLT_FLOAT:
		if ( index->floating.unit ) {
			st = s_open_string_write(&int_cm);
			s_printf(st,"%f%ls",
				index->floating.data,
				index->floating.unit);
			_index = ll_copy_str(s_get_l_string(st));
			s_close(st);
			set_buffer(_index);
		}
		else {
			buf = d_alloc(50);
			sprintf(buf,"%f",
				index->floating.data);
			_index = l_string(std_cm,buf);
		}
		break;
	default:
		goto type_missmatch;
	}
	if ( buf )
		d_f_ree(buf);
	set_env(_e,_index,get_el(s,3));
	return 0;
type_missmatch:
	return get_error(
		s->h.file,
		s->h.line,
		XLE_SEMANTICS_TYPE_MISSMATCH,
		l_string(std_cm,"SetEA"),
		0);
}
